//+------------------------------------------------------------------+
//|                                                     MTF_MATR.mq4 |
//|                                                      par Remjie  |
//|                                                 remjiefx@live.fr |
//+------------------------------------------------------------------+
#property copyright "Remjie"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Blue
#property indicator_color3 Red

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4.
**************************************************************************/

extern int TimeFrame=0;
extern int       ATR_Period=21;
extern double    PuissanceATR=0.618;
extern int       StyleBuffer=0;
extern int       TailleBuffer=2;
extern int       Periodmini=12;
extern double    filtre=2;

double R_ATRA;
double R_ATRP;
double R_ATRP1;
double MA_PeriodA;
double MA_PeriodP;
double MA_PeriodP1;
double MAP;
double MAP1;
double MAA;
double filtreB;
double filtreH;
//--- buffers
double MA[];
double TH[];
double TB[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicator line
   SetIndexStyle(0,DRAW_LINE, StyleBuffer, TailleBuffer);
   SetIndexBuffer(0,MA);
   
   SetIndexStyle(1,DRAW_LINE, StyleBuffer, TailleBuffer);
   SetIndexBuffer(1,TH);
   
   SetIndexStyle(2,DRAW_LINE, StyleBuffer, TailleBuffer);
   SetIndexBuffer(2,TB);
   
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Periode_M1"; break;
      case 5 : TimeFrameStr="Periode_M5"; break;
      case 15 : TimeFrameStr="Periode_M15"; break;
      case 30 : TimeFrameStr="Periode_M30"; break;
      case 60 : TimeFrameStr="Periode_H1"; break;
      case 240 : TimeFrameStr="Periode_H4"; break;
      case 1440 : TimeFrameStr="Periode_D1"; break;
      case 10080 : TimeFrameStr="Periode_W1"; break;
      case 43200 : TimeFrameStr="Periode_MN1"; break;
      default : TimeFrameStr="Timeframe Actuel";
   }
   IndicatorShortName("MTF_MA("+TimeFrameStr+")");

  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF CCI                                            |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();

   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
 
    R_ATRA=iATR(Symbol(),TimeFrame,ATR_Period,y);
    R_ATRP=iATR(Symbol(),TimeFrame,ATR_Period,y+1);
    R_ATRP1=iATR(Symbol(),TimeFrame,ATR_Period,y+2);
   
    MA_PeriodA=R_ATRA*PuissanceATR*10000;
    MA_PeriodP=R_ATRP*PuissanceATR*10000;
    MA_PeriodP1=R_ATRP1*PuissanceATR*10000;
    
    if (MA_PeriodA>Periodmini)
    {
    MA[i]=iMA(NULL,TimeFrame,MA_PeriodA,0,MODE_EMA,PRICE_CLOSE,y);
    }
    else MA[i]=iMA(NULL,TimeFrame,Periodmini,0,MODE_EMA,PRICE_CLOSE,y);
    //calcul de la difference de courbe
    MAP1=iMA(NULL,TimeFrame,MA_PeriodP,0,MODE_EMA,PRICE_CLOSE,y+2);
    MAP=iMA(NULL,TimeFrame,MA_PeriodP,0,MODE_EMA,PRICE_CLOSE,y+1);
    MAA=iMA(NULL,TimeFrame,MA_PeriodA,0,MODE_EMA,PRICE_CLOSE,y);
    filtreH=MAA-(0.0001*filtre);
    filtreB=MAA+(0.0001*filtre);
   
    // Si haussier
    if (MAP1<filtreH)
    {
     if (MA_PeriodA>Periodmini)
     {
     TH[i]=iMA(NULL,TimeFrame,MA_PeriodA,0,MODE_EMA,PRICE_CLOSE,y);
     }
     else TH[i]=iMA(NULL,TimeFrame,Periodmini,0,MODE_EMA,PRICE_CLOSE,y);
    }
    // Si baissier
    if (MAP1>filtreB)
    {
     if (MA_PeriodA>Periodmini)
     {
     TB[i]=iMA(NULL,TimeFrame,MA_PeriodA,0,MODE_EMA,PRICE_CLOSE,y);
     }
     else TB[i]=iMA(NULL,TimeFrame,Periodmini,0,MODE_EMA,PRICE_CLOSE,y);
    }
   }  
     
//
   
  
  
   return(0);
  }
//+------------------------------------------------------------------+